From e0794b5c94db8d8ad6e1c07a14e179efc3b29a0d Mon Sep 17 00:00:00 2001
From: Wen Gong <wgong@codeaurora.org>
Date: Fri, 3 Jul 2020 14:23:19 +0800
Subject: [PATCH 132/134] ath11k: change 11d scan to period run in firmware

firmware run 11d scan period by test, if cc code changed, it indicated to ath11k.

this patch will merge together with "ath11k: fix scan fail for the 1st time of load"
to "ath11k: add 11d scan offload support" and send code review.

Change-Id: Iaad9ff5222f43556d57522dd71e2bd9df6419487
---
 drivers/net/wireless/ath/ath11k/mac.c | 69 +++++++++++++++++++----------------
 drivers/net/wireless/ath/ath11k/mac.h |  3 +-
 drivers/net/wireless/ath/ath11k/reg.c |  2 +-
 3 files changed, 41 insertions(+), 33 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/mac.c b/drivers/net/wireless/ath/ath11k/mac.c
index b71bfcd..73eafe8 100644
--- a/drivers/net/wireless/ath/ath11k/mac.c
+++ b/drivers/net/wireless/ath/ath11k/mac.c
@@ -4507,7 +4507,7 @@ void ath11k_mac_11d_scan_start(struct ath11k *ar, u32 vdev_id)
 
 	mutex_lock(&ar->ab->vdev_id_11d_lock);
 
-	ath11k_dbg(ar->ab, ATH11K_DBG_MAC, "vdev id for 11d scan %d\n",
+	ath11k_dbg(ar->ab, ATH11K_DBG_MAC, "mac vdev id for 11d scan %d\n",
 		   ar->vdev_id_11d_scan);
 
 	if (ar->vdev_id_11d_scan != ATH11K_11D_INV_VDEV_ID)
@@ -4521,7 +4521,7 @@ void ath11k_mac_11d_scan_start(struct ath11k *ar, u32 vdev_id)
 		param.start_interval_msec = 0;
 		param.scan_period_msec = ATH11K_SCAN_11D_INTERVAL;
 
-		ath11k_dbg(ar->ab, ATH11K_DBG_MAC, "start 11d scan\n");
+		ath11k_dbg(ar->ab, ATH11K_DBG_MAC, "mac start 11d scan\n");
 
 		ret = ath11k_wmi_send_11d_scan_start_cmd(ar, &param);
 		if (ret) {
@@ -4535,13 +4535,8 @@ void ath11k_mac_11d_scan_start(struct ath11k *ar, u32 vdev_id)
 			ath11k_dbg(ar->ab, ATH11K_DBG_MAC,
 				   "mac 11d scan left time %d\n", ret);
 
-			if (ret) {
-				mutex_unlock(&ar->ab->vdev_id_11d_lock);
-				ath11k_mac_11d_scan_stop(ar->ab);
-				return;
-			}
-			ar->pending_11d = false;
-			ar->vdev_id_11d_scan = ATH11K_11D_INV_VDEV_ID;
+			if (!ret)
+				ar->pending_11d = false;
 		}
 	}
 
@@ -4549,40 +4544,49 @@ void ath11k_mac_11d_scan_start(struct ath11k *ar, u32 vdev_id)
 	mutex_unlock(&ar->ab->vdev_id_11d_lock);
 }
 
-void ath11k_mac_11d_scan_stop(struct ath11k_base *ab)
+void ath11k_mac_11d_scan_stop(struct ath11k *ar)
 {
 	int ret;
+	u32 vdev_id;
+
+	if (test_bit(WMI_TLV_SERVICE_11D_OFFLOAD, ar->ab->wmi_ab.svc_map)) {
+		ath11k_dbg(ar->ab, ATH11K_DBG_MAC, "mac stop 11d scan\n");
+
+		mutex_lock(&ar->ab->vdev_id_11d_lock);
+
+		ath11k_dbg(ar->ab, ATH11K_DBG_MAC, "mac stop 11d vdev id %d\n",
+			   ar->vdev_id_11d_scan);
+
+		if (ar->vdev_id_11d_scan != ATH11K_11D_INV_VDEV_ID) {
+			vdev_id = ar->vdev_id_11d_scan;
+
+			ret = ath11k_wmi_send_11d_scan_stop_cmd(ar, vdev_id);
+			if (ret)
+				ath11k_warn(ar->ab,
+					    "failed to stopt 11d scan vdev %d ret: %d\n",
+					    vdev_id, ret);
+			else
+				ar->vdev_id_11d_scan = ATH11K_11D_INV_VDEV_ID;
+		}
+		mutex_unlock(&ar->ab->vdev_id_11d_lock);
+	}
+}
+
+void ath11k_mac_11d_scan_stop_all(struct ath11k_base *ab)
+{
 	struct ath11k *ar;
 	struct ath11k_pdev *pdev;
 	int i;
-	u32 vdev_id;
 
 	if (test_bit(WMI_TLV_SERVICE_11D_OFFLOAD, ab->wmi_ab.svc_map)) {
-		ath11k_dbg(ab, ATH11K_DBG_MAC, "stop 11d scan\n");
-
-		mutex_lock(&ab->vdev_id_11d_lock);
+		ath11k_dbg(ab, ATH11K_DBG_MAC, "mac stop soc 11d scan\n");
 
 		for (i = 0; i < ab->num_radios; i++) {
 			pdev = &ab->pdevs[i];
 			ar = pdev->ar;
 
-			ath11k_dbg(ar->ab, ATH11K_DBG_MAC, "stop 11d vdev id %d\n",
-				   ar->vdev_id_11d_scan);
-
-			if (ar->vdev_id_11d_scan != ATH11K_11D_INV_VDEV_ID) {
-				vdev_id = ar->vdev_id_11d_scan;
-
-				ret = ath11k_wmi_send_11d_scan_stop_cmd(ar, vdev_id);
-				if (ret)
-					ath11k_warn(ar->ab,
-						    "failed to stopt 11d scan vdev %d ret: %d\n",
-						    vdev_id, ret);
-				else
-					ar->vdev_id_11d_scan = ATH11K_11D_INV_VDEV_ID;
-			}
+			ath11k_mac_11d_scan_stop(ar);
 		}
-
-		mutex_unlock(&ab->vdev_id_11d_lock);
 	}
 }
 
@@ -4741,7 +4745,7 @@ static int ath11k_mac_op_add_interface(struct ieee80211_hw *hw,
 			goto err_peer_del;
 		}
 
-		ath11k_mac_11d_scan_stop(ar->ab);
+		ath11k_mac_11d_scan_stop_all(ar->ab);
 		break;
 	case WMI_VDEV_TYPE_STA:
 		param_id = WMI_STA_PS_PARAM_RX_WAKE_POLICY;
@@ -4859,6 +4863,9 @@ static void ath11k_mac_op_remove_interface(struct ieee80211_hw *hw,
 	list_del(&arvif->list);
 	spin_unlock_bh(&ar->data_lock);
 
+	if (arvif->vdev_type == WMI_VDEV_TYPE_STA)
+		ath11k_mac_11d_scan_stop(ar);
+
 	if (arvif->vdev_type == WMI_VDEV_TYPE_AP) {
 		ret = ath11k_peer_delete(ar, arvif->vdev_id, vif->addr);
 		if (ret)
diff --git a/drivers/net/wireless/ath/ath11k/mac.h b/drivers/net/wireless/ath/ath11k/mac.h
index 3cc8db7..7c6cabc 100644
--- a/drivers/net/wireless/ath/ath11k/mac.h
+++ b/drivers/net/wireless/ath/ath11k/mac.h
@@ -122,7 +122,8 @@ extern const struct htt_rx_ring_tlv_filter ath11k_mac_mon_status_filter_default;
 #define ATH11K_11D_INV_VDEV_ID		0xFFFF
 
 void ath11k_mac_11d_scan_start(struct ath11k *ar, u32 vdev_id);
-void ath11k_mac_11d_scan_stop(struct ath11k_base *ab);
+void ath11k_mac_11d_scan_stop(struct ath11k *ar);
+void ath11k_mac_11d_scan_stop_all(struct ath11k_base *ab);
 void ath11k_mac_handle_beacon(struct ath11k *ar, struct sk_buff *skb);
 void ath11k_mac_handle_beacon_miss(struct ath11k *ar, u32 vdev_id);
 
diff --git a/drivers/net/wireless/ath/ath11k/reg.c b/drivers/net/wireless/ath/ath11k/reg.c
index 023e60d..963f166 100644
--- a/drivers/net/wireless/ath/ath11k/reg.c
+++ b/drivers/net/wireless/ath/ath11k/reg.c
@@ -75,7 +75,7 @@ ath11k_reg_notifier(struct wiphy *wiphy, struct regulatory_request *request)
 		return;
 	}
 
-	ath11k_mac_11d_scan_stop(ar->ab);
+	ath11k_mac_11d_scan_stop(ar);
 
 	if (ar->ab->hw_params.single_pdev_only) {
 		memcpy(&set_current_param.alpha2, request->alpha2, 2);
-- 
2.7.4

